/* This software is licensed by the MIT License, see LICENSE file */
/*                                Copyright © 2022 Gregory Lirent */

#include <string.h>
#include "../__attributes.h"

#ifndef LIBCDSB_EXTRA_CSTRING_H
#define LIBCDSB_EXTRA_CSTRING_H

extern size_t libcdsb_strlen     (const char* s) LIBCDSB_pure__ LIBCDSB_nn1__;
extern size_t libcdsb_strasciilen(const char* s) LIBCDSB_pure__ LIBCDSB_nn1__;

extern char* libcdsb_strdup (const char* s)           LIBCDSB_nt__ LIBCDSB_wur__ LIBCDSB_nn1__;
extern char* libcdsb_strndup(const char* s, size_t n) LIBCDSB_nt__ LIBCDSB_wur__ LIBCDSB_nn1__;
extern void* libcdsb_memndup(const void* m, size_t n) LIBCDSB_nt__ LIBCDSB_wur__ LIBCDSB_nn1__;

#define strlen      libcdsb_strlen
#define strasciilen libcdsb_strasciilen

#define strdup  libcdsb_strdup
#define strndup libcdsb_strndup
#define memndup libcdsb_memndup

#endif /* LIBCDSB_EXTRA_CSTRING_H */
