/* This software is licensed by the MIT License, see LICENSE file */
/*                                Copyright © 2022 Gregory Lirent */

#include <stddef.h>
#include "../__attributes.h"

#ifndef LIBCDSB_EXTRA_MEMORY_H
#define LIBCDSB_EXTRA_MEMORY_H

extern void* libcdsb_aalloc (size_t a, size_t n) LIBCDSB_nt__ LIBCDSB_wur__;
extern void* libcdsb_malloc (size_t n)           LIBCDSB_nt__ LIBCDSB_wur__;
extern void* libcdsb_calloc (size_t n, size_t c) LIBCDSB_nt__ LIBCDSB_wur__;
extern void* libcdsb_realloc(void  *p, size_t n) LIBCDSB_nt__ LIBCDSB_wur__;

#define aligned_alloc libcdsb_aalloc
#define malloc        libcdsb_malloc
#define calloc        libcdsb_calloc
#define realloc       libcdsb_realloc

#endif /* LIBCDSB_EXTRA_MEMORY_H */
