/* This software is licensed by the MIT License, see LICENSE file */
/*                                Copyright © 2022 Gregory Lirent */

#include "include.h"

ssize_t libcdsb_array_indexof_pointer(const arr_t* x, const   void* v) { return array_find(x, &v, vtypeof(&v)); }
ssize_t libcdsb_array_indexof_string (const arr_t* x, const   char* v) { return array_find(x, &v, vtypeof(&v)); }
ssize_t libcdsb_array_indexof_array  (const arr_t* x, const  str_t* v) { return array_find(x,  v, vtypeof( v)); }
ssize_t libcdsb_array_indexof_list   (const arr_t* x, const  arr_t* v) { return array_find(x,  v, vtypeof( v)); }
ssize_t libcdsb_array_indexof_map    (const arr_t* x, const list_t* v) { return array_find(x,  v, vtypeof( v)); }
ssize_t libcdsb_array_indexof_vset   (const arr_t* x, const  map_t* v) { return array_find(x,  v, vtypeof( v)); }
ssize_t libcdsb_array_indexof_cstring(const arr_t* x, const  set_t* v) { return array_find(x,  v, vtypeof( v)); }
ssize_t libcdsb_array_indexof_boolean(const arr_t* x,         _Bool v) { return array_find(x, &v, vtypeof(&v)); }
ssize_t libcdsb_array_indexof_int8   (const arr_t* x,          s8_t v) { return array_find(x, &v, vtypeof(&v)); }
ssize_t libcdsb_array_indexof_int16  (const arr_t* x,         s16_t v) { return array_find(x, &v, vtypeof(&v)); }
ssize_t libcdsb_array_indexof_int32  (const arr_t* x,         s32_t v) { return array_find(x, &v, vtypeof(&v)); }
ssize_t libcdsb_array_indexof_int64  (const arr_t* x,         s64_t v) { return array_find(x, &v, vtypeof(&v)); }
ssize_t libcdsb_array_indexof_uint8  (const arr_t* x,          u8_t v) { return array_find(x, &v, vtypeof(&v)); }
ssize_t libcdsb_array_indexof_uint16 (const arr_t* x,         u16_t v) { return array_find(x, &v, vtypeof(&v)); }
ssize_t libcdsb_array_indexof_uint32 (const arr_t* x,         u32_t v) { return array_find(x, &v, vtypeof(&v)); }
ssize_t libcdsb_array_indexof_uint64 (const arr_t* x,         u64_t v) { return array_find(x, &v, vtypeof(&v)); }
ssize_t libcdsb_array_indexof_float  (const arr_t* x,          fl_t v) { return array_find(x, &v, vtypeof(&v)); }
ssize_t libcdsb_array_indexof_double (const arr_t* x,         dbl_t v) { return array_find(x, &v, vtypeof(&v)); }
ssize_t libcdsb_array_indexof_ldouble(const arr_t* x,        ldbl_t v) { return array_find(x, &v, vtypeof(&v)); }

void libcdsb_array_push_pointer(arr_t* x, const   void* v) { array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_cstring(arr_t* x, const   char* v) { array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_string (arr_t* x, const  str_t* v) { array_push(x,  v, vtypeof( v)); }
void libcdsb_array_push_array  (arr_t* x, const  arr_t* v) { array_push(x,  v, vtypeof( v)); }
void libcdsb_array_push_list   (arr_t* x, const list_t* v) { array_push(x,  v, vtypeof( v)); }
void libcdsb_array_push_map    (arr_t* x, const  map_t* v) { array_push(x,  v, vtypeof( v)); }
void libcdsb_array_push_vset   (arr_t* x, const  set_t* v) { array_push(x,  v, vtypeof( v)); }
void libcdsb_array_push_boolean(arr_t* x,         _Bool v) { array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_int8   (arr_t* x,          s8_t v) { array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_int16  (arr_t* x,         s16_t v) { array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_int32  (arr_t* x,         s32_t v) { array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_int64  (arr_t* x,         s64_t v) { array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_uint8  (arr_t* x,          u8_t v) { array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_uint16 (arr_t* x,         u16_t v) { array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_uint32 (arr_t* x,         u32_t v) { array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_uint64 (arr_t* x,         u64_t v) { array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_float  (arr_t* x,          fl_t v) { array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_double (arr_t* x,         dbl_t v) { array_push(x, &v, vtypeof(&v)); }
void libcdsb_array_push_ldouble(arr_t* x,        ldbl_t v) { array_push(x, &v, vtypeof(&v)); }
