/* This software is licensed by the MIT License, see LICENSE file */
/*                                Copyright © 2022 Gregory Lirent */

#include "include.h"

size_t string_replace_cstring_cstring(str_t* x, const char* a, const char* d, size_t maxn) {
    char* p;
    size_t c, an, dn;

    if (is_null(x->buffer) || is_null(a) || !*x->buffer || !*a) {
        return 0;
    }

    an = strlen(a);
    dn = (!is_null(d)) ? strlen(d) : 0;
    p  = x->buffer;
    c  = 0;

    while (maxn-- && !is_null(p = strstr(p, a))) {
        string_replace(x, p, an, d, dn);
        p += an;
        ++c;
    }

    return c;
}


size_t string_replace_cstring_char(str_t* x, const char* a, int dc, size_t maxn) {
    char* p;
    char d[4];
    size_t c, an, dn;

    if (is_null(x->buffer) || is_null(a) || !*x->buffer || !*a) {
        return 0;
    }

    an = strlen(a);
    p  = tochar_unicode(d, dc);
    dn = (!is_null(p)) ? p - d : 0;
    p  = x->buffer;
    c  = 0;

    while (maxn-- && !is_null(p = strstr(p, a))) {
        string_replace(x, p, an, d, dn);
        p += an;
        ++c;
    }

    return c;
}


size_t string_replace_char_cstring(str_t* x, int ac, const char* d, size_t maxn) {
    char* p;
    char a[4];
    size_t c, an, dn;

    p = tochar_unicode(a, ac);

    if (is_null(x->buffer) || is_null(p) || !*x->buffer || !*p) {
        return 0;
    }

    an = p - a;
    dn = (!is_null(d)) ? strlen(d) : 0;
    p  = x->buffer;
    c  = 0;

    while (maxn-- && !is_null(p = strstr(p, a))) {
        string_replace(x, p, an, d, dn);
        p += an;
        ++c;
    }

    return c;
}


size_t string_replace_char_char(str_t* x, int ac, int dc, size_t maxn) {
    char* p;
    char a[4];
    char d[4];
    size_t c, an, dn;

    p = tochar_unicode(a, ac);

    if (is_null(x->buffer) || is_null(p) || !*x->buffer || !*p) {
        return 0;
    }

    an = p - a;
    p  = tochar_unicode(d, dc);
    dn = (!is_null(p)) ? p - d : 0;
    p  = x->buffer;
    c  = 0;

    while (maxn-- && !is_null(p = strstr(p, a))) {
        string_replace(x, p, an, d, dn);
        p += an;
        ++c;
    }

    return c;
}
