/* This software is licensed by the MIT License, see LICENSE file */
/*                                Copyright © 2022 Gregory Lirent */

#include "plug.h"

static void array_find_minimal(const vtype_array* x) {
    array_print(x, 0);
    for (vtype_uint64 v = 0; v < UINT64_MAX; ++v) {
        ssize_t index = array_indexof(x, v);
        if (index >= 0) {
            printf("\e[36mValue \e[m\e[31m%lu\e[m\e[36m was found at the position \e[m\e[32;1m%ld\e[m\n", v, index);
            break;
        }
    }
    put_separator();
}

int main(int argc, char** argv) {
    test_init(argc, argv);

    vtype_array x = { .mem = 0 };

    do {
        array_free(&x);
        x = array_random(8);
    } while (x.type >= VTYPE_FLOAT);

    array_info(&x);
    array_find_minimal(&x);

    array_reverse(&x);
    array_print(&x, "reversed");

    array_sort(&x);
    array_print(&x, "sorted");

    array_free(&x);
}
